(*
    ===========================================================================

    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------
    Using Hooks
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm


    ---------------------------------------------------------------------------
    2003/11/25  n

    ===========================================================================
*)


unit HookMain;

interface

uses
    Windows, Messages, iFMO, iHookTypes;

(*
    ===========================================================================
    export
    ===========================================================================
*)

//  tbNCXg[
function    HookInstall(Wnd: HWND): Boolean; export; stdcall;

//  tbNACXg[
procedure   HookUnInstall(); export; stdcall;

implementation

(*
    ===========================================================================
    type
    ===========================================================================
*)

//  L̓eɂ\
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow: HWND;         //  ʒmEBhE
        HookHandle: HHOOK;        //  tbÑnh
    end;

//  tbN֐^
type
    THookProc = function(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

//  LłȂeɂ\
type
    PLocalHookInfo = ^TLocalHookInfo;
    TLocalHookInfo = record
        Hooked   : Boolean;     //  tbNtO
        HookProc : THookProc;   //  tbN֐
        FmoHandle: THandle;     //  FMOnh
        FmoName  : ShortString; //  FMOʖ
    end;

(*
    ===========================================================================
    var
    ===========================================================================
*)
//  tbN֐̃CXg[Ɋւێ
var
    CbtLhi: TLocalHookInfo;
    MouseLhi: TLocalHookInfo;

(******************************************************************************)

(*
    ===========================================================================
    CBTProc
    ===========================================================================
*)
function    CBTProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

    //  -------------------------------------------------
    //  _CAOǂ
    function    IsDialog(WH: integer): Boolean;
    begin
        Result := (GetClassNameStr(WH) = DLG_CLASS_NAME);
    end;
    //  -------------------------------------------------

var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;

    CreateWnd  : integer;
    DestroyWnd : integer;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, CbtLhi.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  ܂ꂽăEBhE
        HCBT_CREATEWND:
            begin
                //  쐬EBhẼnh
                CreateWnd := wParam;
                //  ̃EBhEgbvEBhEǂ
                if (IsTopLevelWindow(CreateWnd)) then
                begin
                    //  _CAOH
                    if IsDialog(CreateWnd) then
                    begin
                        PostMessage(Shi^.HostWindow, UM_CREATEWND, CreateWnd, 0);
                    end;
                end;
            end;

        //  ɂEBhE
        HCBT_DESTROYWND:
            begin
                //  jEBhẼnh
                DestroyWnd := wParam;
                //  _CAOH
                if IsDialog(DestroyWnd) then
                begin
                    PostMessage(Shi^.HostWindow, UM_DESTROYWND, DestroyWnd, 0);
                end;
            end;

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle, nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    MouseProc
    ===========================================================================
*)
function    MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

    //  -------------------------------------------------
    //  ̃^C~Oǂ
    function    IsTimeing(AMsg: integer): Boolean;
    begin
        Result := (AMsg = WM_LBUTTONUP);
    end;
    //  -------------------------------------------------

var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, MouseLhi.FmoName);

    //  tbN\̏
    Shi := PShareHookInfo(p);

    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  }EXANV
        HC_ACTION:
            begin
                if IsTimeing(wParam) then
                begin
                    PostMessage(Shi^.HostWindow, UM_MOUSEACTION, 0, 0);
                end;
            end;

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HookHandle, nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(******************************************************************************)

(*
    ===========================================================================
    tbNCXg[
    ===========================================================================
*)
function    HookInstall(Wnd: HWND): Boolean;
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, CbtLhi.FmoName);

    //  tbN\̏(邢͎擾)
    Shi := PShareHookInfo(p);

    try
        //  Ƒ҂āBłɒNtbNĂ肵Ă˂낤ȁB
        if (Shi^.HostWindow <> 0) and (Shi^.HostWindow <> Wnd) then
        begin
            RaiseAlwaysCreatedByOtherWindowMMF(Shi^.HostWindow);
        end;

        //  ʒmL^
        Shi^.HostWindow := Wnd;

        //  tbN֐̓o^
        Shi^.HookHandle := SetWindowsHookEx(WH_CBT, CbtLhi.HookProc, HInstance, 0);

        //  tbN
        CbtLhi.Hooked := (Shi^.HookHandle > 0);

    finally
        //  MMFgpI
        ReleaseFileMappingObject(hFMO, p);
    end;

    //  -----

    //  MMFgp
    GetFileMappingObject(hFMO, p, MouseLhi.FmoName);

    //  tbN\̏(邢͎擾)
    Shi := PShareHookInfo(p);

    try
        //  Ƒ҂āBłɒNtbNĂ肵Ă˂낤ȁB
        if (Shi^.HostWindow <> 0) and (Shi^.HostWindow <> Wnd) then
        begin
            RaiseAlwaysCreatedByOtherWindowMMF(Shi^.HostWindow);
        end;

        //  ʒmL^
        Shi^.HostWindow := Wnd;

        //  tbN֐̓o^
        Shi^.HookHandle := SetWindowsHookEx(WH_MOUSE, MouseLhi.HookProc, HInstance, 0);

        //  tbN
        MouseLhi.Hooked := (Shi^.HookHandle > 0);

    finally
        //  MMFgpI
        ReleaseFileMappingObject(hFMO, p);
    end;

    //  ------

    Result := CbtLhi.Hooked and MouseLhi.Hooked;

end;

(*
    ===========================================================================
    tbNACXg[
    ===========================================================================
*)
procedure   HookUnInstall();
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, CbtLhi.FmoName);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //tbN
    if CbtLhi.Hooked then
    begin
        UnhookWindowsHookEx(Shi^.HookHandle);
    end;
    //  MMFgpI
    ReleaseFileMappingObject(hFMO, p);

    //  MMFgp
    GetFileMappingObject(hFMO, p, MouseLhi.FmoName);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //tbN
    if MouseLhi.Hooked then
    begin
        UnhookWindowsHookEx(Shi^.HookHandle);
    end;
    //  MMFgpI
    ReleaseFileMappingObject(hFMO, p);
end;

(******************************************************************************)

(*
    ===========================================================================
    initialization
    ===========================================================================
*)
initialization
begin
    //  MMF 쐬

    //  CBTtbNp
    FillChar(CbtLhi, SizeOf(CbtLhi), #0);
    CbtLhi.HookProc := CBTProc;
    CbtLhi.FmoName := 'CBT_HOOK_PROC';
    CbtLhi.FmoHandle := CreateFileMappingObject(SizeOf(TShareHookInfo), CbtLhi.FmoName);
    //  MousetbNp
    FillChar(MouseLhi, SizeOf(MouseLhi), #0);
    MouseLhi.HookProc := MouseProc;
    MouseLhi.FmoName := 'MOUSE_HOOK_PROC';
    MouseLhi.FmoHandle := CreateFileMappingObject(SizeOf(TShareHookInfo), MouseLhi.FmoName);
end;

(*
    ===========================================================================
    finalization
    ===========================================================================
*)
finalization
begin
    //  MMF 

    //  CBTtbNp
    DestroyFileMappingObject(CbtLhi.FmoHandle);
    //  MousetbNp
    DestroyFileMappingObject(MouseLhi.FmoHandle);
end;

end.

