unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Data(Control: TWinControl; Index: Integer;
      var Data: String);
  private
    WndProc     : TWndMethod;
    WindowHandleList: TStringList;

    procedure   HookedCBTProc(var Msg: TMessage);
    procedure   MessageOut(AMsg: string);
  public

  end;

var
  MainForm: TMainForm;

implementation

uses
    ShlObj, ActiveX, dlgs, iHookTypes;

{$R *.dfm}

(******************************************************************************)

(*
    ===========================================================================
    DLLC|[gEăX^eBbNN
    ===========================================================================
*)
function    HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstall(); stdcall;external HOOK_DLL_NAME;

(******************************************************************************)

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure TMainForm.MessageOut(AMsg: string);
begin
    ;
end;

(******************************************************************************)

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ʒu
    Self.Top := Screen.Height - Self.Height;
    Self.Left := Screen.Width - Self.Width;
    //  EBhEnhێXg쐬
    WindowHandleList := TStringList.Create;
    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := HookedCBTProc;
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

(*
    ===========================================================================
    tH[fXgN^
    ===========================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  tbNACXg[
    HookUnInstall();
    //  łEBhEvV[W߂
    Self.WindowProc := WndProc;
    //  EBhEnhێXgj
    WindowHandleList.Free;
end;

(*
    ===========================================================================
    Open/SaveAs_CAOǂ()
    ---------------------------------------------------------------------------
    http://www1.harenet.ne.jp/cgi-bin/cgiwrap/unaap/chtml/chtml.cgi?key=comdlg1
    ===========================================================================
*)
function    IsOpenSaveAsDialog(WH: HWND): Boolean;
var
    Check: HWND;
begin
    Result := false;

    //  ȉɏグWƎvRg[ĂOK

    Check := GetDlgItem(WH, stc2);         //  t@C̎(&T)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, stc3);         //  t@C(&N)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, stc4);         //  t@C̏ꏊ(&I)
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, cmb2);         //  t@C̏ꏊIR{
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, lst1);         //  Xgr[
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, chx1);         //  ǎpt@CƂĊJ(&R)`FbN
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, cmb1);         //  t@C̎ޑIR{
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, edt1);         //  t@C̓GfBbg
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, IDOK);         //  J(&O){^
    if (Check = 0) then Exit;
    Check := GetDlgItem(WH, IDCANCEL);     //  LZ{^
    if (Check = 0) then Exit;

    Result := true;
end;

(*
    ===========================================================================
    fXNgbvpX擾
    ---------------------------------------------------------------------------
    http://homepage1.nifty.com/MADIA/delphi/Win32API/ShFolder.htm
    http://homepage2.nifty.com/Mr_XRAY/Delphi/plFileDialog/B_BrowseFolder.htm
    ===========================================================================
*)
function    GetDeskTopPath():string;
var
    Root : PItemIDList;
    Buffer: PChar;
    Memory: IMalloc;
begin
    SHGetMalloc(Memory);
    Buffer := Memory.Alloc(MAX_PATH);
    //  tH_̈ʒu擾
    SHGetSpecialFolderLocation(Application.MainForm.Handle, CSIDL_DESKTOP, Root);
    //  ItemIDList\̂pXo
    SHGetPathFromIDList(Root, Buffer);
    Result := Buffer;
    //  ̉
    Memory.Free(Root);
    Memory.Free(Buffer);
end;

(*
    ===========================================================================
    }EXfXNgbvɂꍇɃfXNgbvւ̃pXԂ
    }EXtH_ɂꍇɂ̃tH_ւ̃pXԂ
    }EXGNXv[ɂꍇɂ̃tH_ւ̃pXԂ
    }EX悭Ȃꏊɂꍇɂ͋󕶎Ԃ
    ---------------------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA020801/lnkpg/sample/getexp.txt
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabeapp.htm
    ===========================================================================
*)
function    GetFullPathOfMouse(): string;
var
    WndClassName: string;
    Buf: array[0..255] of Char;
    WH: HWND;
begin
    Result := '';
    //  }EX̃EBhËԓVӂ̐eEBhẼnh
    WH := GetMostTopLevelWindow(WindowFromPoint(Mouse.CursorPos));
    //  ̃EBhẼNX
    WndClassName := GetClassNameStr(WH);
    //  fobO
    Application.MainForm.Caption := WndClassName;
    //  tH_GNXv[
    if (WndClassName = 'CabinetWClass') or (WndClassName = 'ExploreWClass') then
    begin
        //  WorkerW EBhE
        WH := FindWindowEx(WH, 0, 'WorkerW', nil);
        if (WH <> 0) then
        begin
            //  ReBarWindow32 EBhE  
            WH := FindWindowEx(WH, 0, 'ReBarWindow32', nil);
            if (WH <> 0) then
            begin
                //  ComboBoxEx32 EBhE
                WH := FindWindowEx(WH, 0, 'ComboBoxEx32', nil);
                if (WH <> 0) then
                begin
                    //  ̃eLXg擾
                    FillChar(Buf, SizeOf(Buf), #0);
                    SendMessage(WH, WM_GETTEXT, SizeOf(Buf), Integer(@Buf));
                    Result := Buf;
                end;
            end;
        end;
    end
    else
    //  fXNgbv
    if (WndClassName = 'Progman') then
    begin
        Result := GetDeskTopPath();
    end;
end;

(*
    ===========================================================================
    w̃_CAOɃpXύXĂ݂
    ---------------------------------------------------------------------------
    http://www.kumei.ne.jp/c_lang/sdk4/sdk_301.htm
    http://forum.nifty.com/fdelphi/samples/00908.html
    ===========================================================================
*)
procedure   SetDialogPath(WH: HWND; Path: string);
var
    EditWH, OkWH: HWND;
    Buf: array[0..255] of Char;
    PreText: string;
begin
    //  EditRg[
    EditWH := GetDlgItem(WH, edt1);
    //  ̕obNAbvĂ
    FillChar(Buf, SizeOf(Buf), #0);
    SendMessage(EditWH, WM_GETTEXT, SizeOf(Buf), Integer(@Buf));
    PreText := Buf;
    //  
    SendMessage(EditWH, WM_SETTEXT, 0, Longint(PChar(Path)));
    //  OK{^
    OkWH := GetDlgItem(WH, IDOK);
    //  OK{^
    SendMessage(OkWH, BM_CLICK, 0, 0);
    //  ɖ߂
    SendMessage(EditWH, WM_SETTEXT, 0, Longint(PChar(PreText)));
end;

(*
    ===========================================================================
    ւpEBhEvV[W
    ---------------------------------------------------------------------------
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/
    hookreference/hookfunctions/cbtproc.htm
    ===========================================================================
*)
procedure TMainForm.HookedCBTProc(var Msg: TMessage);
var
    WH: HWND;
    WndClassName: string;
    WndWindowTxt: string;
    MsgStr: string;
    Index: integer;
    NewPath: string;
begin

    case Msg.Msg of

        //  EBhE쐬
        UM_CREATEWND:
        begin

            WH           := Msg.WParam;
            WndClassName := GetClassNameStr(WH);
            WndWindowTxt := GetWindowTextStr(WH);
            MsgStr := Format('HCBT_CREATEWND  | HWND=%10d | CLASS=%s | TEXT=%s', [WH, WndClassName, WndWindowTxt]);
            MessageOut(MsgStr);

            if IsOpenSaveAsDialog(WH) then
            begin
                WindowHandleList.Add(IntToStr(WH));
            end;
            ListBox1.Count := WindowHandleList.Count;
            if (ListBox1.Count > 0) then ListBox1.ItemIndex := ListBox1.Count - 1;
        end;

        //  EBhEj
        UM_DESTROYWND:
        begin
            WH    := Msg.WParam;
            Index := WindowHandleList.IndexOf(IntToStr(WH));
            if (Index <> -1) then WindowHandleList.Delete(Index);
            MsgStr := Format('HCBT_DESTROYWND | HWND=%10d', [WH]);
            MessageOut(MsgStr);

            ListBox1.Count := WindowHandleList.Count;
        end;

        //  pXύX
        UM_MOUSEACTION:
        begin
            NewPath := GetFullPathOfMouse();
            if (NewPath <> '') and (ListBox1.ItemIndex <> -1) then
            begin
                WH := StrToInt(WindowHandleList[ListBox1.ItemIndex]);
                SetDialogPath(WH, NewPath);
            end;
        end;

    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

(*
    ===========================================================================
    Ď̃EBhEnhꗗ
    ===========================================================================
*)
procedure TMainForm.ListBox1Data(Control: TWinControl; Index: Integer;
  var Data: String);
begin
    Data := WindowHandleList[Index];
end;

end.

